@echo off
echo #################################################
echo #
echo # KIP-AFS Windows XP and 7 Installaion Script
echo #
echo # Date: 03.09.2013 
echo #
echo # Contact: edv@kip.uni-heidelberg.de
echo #
echo #################################################

:: Check for administrative privileges

mkdir %systemroot%\testadmindir

if not %errorlevel% EQU 0 (
 echo Run this script as Administrator - right click file !!!
 pause
 exit 1
)

rmdir %systemroot%\testadmindir

echo Ready? If not press STRG+C or close the window, or
echo press any key to continue
pause 

:: Set Timeserver

net start w32time 

w32tm /config /syncfromflags:manual /manualpeerlist:ntp.kip.uni-heidelberg.de

w32tm /config /update

w32tm /resync /nowait

w32tm /query /status | find "ntp.kip.uni-heidelberg.de"

:: if %errorlevel% NEQ 0 echo "Warning: Timeserver not set - Please check your NTP settings manually !"

:: Download Software from ceres

set remotepath=x:
if exist %remotepath% net use %remotepath% /delete

:: net use %remotepath% \\ceres.kip.uni-heidelberg.de\freesoft\afs /USER:user
net use %remotepath% \\gfs.kip.uni-heidelberg.de\software\afs

set localpath=%TEMP%\afs_soft
if not exist "%localpath%" mkdir "%localpath%"

systeminfo | find "x64-based PC"
if %errorlevel% EQU 0 (set arch=64bit) else (set arch=32bit)
:: echo check_arch is: %arch%

systeminfo | find "Windows XP"
if %errorlevel% EQU 0 (set wversion=winxp) else (set wversion=win7)

:: copy for installation 
xcopy /y %remotepath%\%arch%\* %localpath%
xcopy /y %remotepath%\* %localpath%

:: cleanup 
if exist %remotepath% net use %remotepath% /delete	

:: copy AFS & Kerberos config files
if not exist "%ProgramFiles%\OpenAFS\Client" mkdir "%ProgramFiles%\OpenAFS\Client"
xcopy /yr %localpath%\CellServDB "%ProgramFiles%\OpenAFS\Client"
xcopy /yr %localpath%\CellAlias "%ProgramFiles%\OpenAFS\Client"
xcopy /yr %localpath%\ThisCell "%ProgramFiles%\OpenAFS\Client"

echo #### detected windows version: %wversion% %arch%  ####

if %wversion%==win7 (GOTO WIN7_SECTION) else (GOTO WINXP_SECTION)

:WINXP_SECTION

echo #### installing software for WindowsXP #### 

copy /y %localpath%\krb5.ini "%SystemRoot%"

if %arch%==64bit (
 %localpath%\Heimdal-AMD64-full-1-5-100-930.msi 
 %localpath%\netidmgr-AMD64-rel-2_0_102_907.msi
 %localpath%\openafs-32bit-tools-en_US-1-7-3100.msi
 %localpath%\openafs-en_US-64bit-1-7-3100.msi
) else (
 %localpath%\kfw-3-2-2.exe
 %localpath%\openafs-en_US-1-7-3100.msi
) 
GOTO END

:WIN7_SECTION

echo #### installing software for Windows7 #### 

if not exist "%AllUsersProfile%\Kerberos\" mkdir %AllUsersProfile%\Kerberos\"

xcopy /yr %localpath%\krb5.conf "%AllUsersProfile%\Kerberos\"

:: xcopy /yr %localpath%\krb5.ini "%AllUsersProfile%\Kerberos\" 

copy /y %localpath%\krb5.ini "%SystemRoot%"

if %arch%==64bit ( 
 %localpath%\Heimdal-AMD64-full-1-5-100-930.msi 
 %localpath%\netidmgr-AMD64-rel-2_0_102_907.msi
 %localpath%\openafs-32bit-tools-en_US-1-7-3100.msi
 %localpath%\openafs-en_US-64bit-1-7-3100.msi
) else (
 %localpath%\kfw-3-2-2.exe
 %localpath%\openafs-en_US-1-7-3100.msi
) 
GOTO END

:END
:: cleanup
rmdir %localpath%
pause
echo Installation finished, please reboot!
exit 0

:: Notes
:: DLLs for Heimdal 32 Bit krbv4w32.dll and krb524.dll
:: xcopy /yr %localpath%\krbv4w32.dll "%ProgramFiles%\MIT\Kerberos\bin"
:: xcopy /yr %localpath%\krb524.dll "%ProgramFiles%\MIT\Kerberos\bin"

:: %localpath%\Heimdal-i386-1-5-100-930.msi
:: %localpath%\netidmgr-i386-rel-2_0_102_907.msi 
 
